//+------------------------------------------------------------------+
//|                                                AdaptiveRenko.mq5 |
//|                                    Copyright  2010,   Svinozavr | 
//|                                                                  | 
//+------------------------------------------------------------------+
#property copyright "Copyright  2010,   Svinozavr"
#property link ""
#property description " "
//----   
#property version   "1.10"
//----     
#property indicator_chart_window 
//----       4
#property indicator_buffers 4
//----     
#property indicator_plots   4
//+----------------------------------------------+
//|                  |
//+----------------------------------------------+
//----   1   
#property indicator_type1   DRAW_LINE
//----      DodgerBlue 
#property indicator_color1  DodgerBlue
//----   - 
#property indicator_style1 STYLE_DASHDOTDOT
//----   1  1
#property indicator_width1  1
//----    
#property indicator_label1  "Lower AdaptiveRenko"
//+----------------------------------------------+
//|                  |
//+----------------------------------------------+
//----   2   
#property indicator_type2   DRAW_LINE
//----      Magenta 
#property indicator_color2  Magenta
//----   - 
#property indicator_style2 STYLE_DASHDOTDOT
//----   2  1
#property indicator_width2  1
//----    
#property indicator_label2 "Upper AdaptiveRenko"
//+----------------------------------------------+
//|                  |
//+----------------------------------------------+
//----   3   
#property indicator_type3   DRAW_LINE
//----      Lime 
#property indicator_color3  Lime
//----   - 
#property indicator_style3 STYLE_SOLID
//----   3  4
#property indicator_width3  4
//----    
#property indicator_label3  "AdaptiveRenko Support"
//+----------------------------------------------+
//|                  |
//+----------------------------------------------+
//----   4   
#property indicator_type4   DRAW_LINE
//----      Red 
#property indicator_color4  Red
//----   - 
#property indicator_style4 STYLE_SOLID
//----   4  4
#property indicator_width4  4
//----    
#property indicator_label4 "AdaptiveRenko Resistance"
//+----------------------------------------------+
//|                            |
//+----------------------------------------------+
#define RESET 0 //        
//+----------------------------------------------+
//|                        |
//+----------------------------------------------+
enum IndMode // 
  {
   ATR,     //ATR 
   StDev    //StDev 
  };
//+----------------------------------------------+
//|                        |
//+----------------------------------------------+
enum PriceMode // 
  {
   HighLow_, //High/Low
   Close_    //Close
  };
//+----------------------------------------------+
//|                    |
//+----------------------------------------------+
input double K=1; //
input IndMode Indicator=ATR; //  
input uint VltPeriod=10; //  
input PriceMode Price=Close_; //  
input uint WideMin=2; //     
//+----------------------------------------------+
double sens;
//----   ,    
//      
double DnBuffer[],UpBuffer[];
double UpTrendBuffer[],DnTrendBuffer[];
//----      
int  min_rates_total;
//----       
int Ind_Handle;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void OnInit()
  {
//----      
   min_rates_total=int(VltPeriod);
   sens=WideMin*_Point;

   if(Indicator==ATR) Ind_Handle=iATR(NULL,0,VltPeriod);
   else  Ind_Handle=iStdDev(NULL,0,VltPeriod,0,MODE_SMA,PRICE_CLOSE);
   if(Ind_Handle==INVALID_HANDLE) Print("     ");

//----      
   SetIndexBuffer(0,UpBuffer,INDICATOR_DATA);
//----       1
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,min_rates_total);
//----       
   ArraySetAsSeries(UpBuffer,true);
//----   ,      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,0);

//----      
   SetIndexBuffer(1,DnBuffer,INDICATOR_DATA);
//----       2
   PlotIndexSetInteger(1,PLOT_DRAW_BEGIN,min_rates_total);
//----       
   ArraySetAsSeries(DnBuffer,true);
//----   ,      
   PlotIndexSetDouble(1,PLOT_EMPTY_VALUE,0);

//----      
   SetIndexBuffer(2,UpTrendBuffer,INDICATOR_DATA);
//----       3
   PlotIndexSetInteger(2,PLOT_DRAW_BEGIN,min_rates_total);
//----       
   ArraySetAsSeries(UpTrendBuffer,true);
//----   ,      
   PlotIndexSetDouble(2,PLOT_EMPTY_VALUE,0);

//----      
   SetIndexBuffer(3,DnTrendBuffer,INDICATOR_DATA);
//----       4
   PlotIndexSetInteger(3,PLOT_DRAW_BEGIN,min_rates_total);
//----       
   ArraySetAsSeries(DnTrendBuffer,true);
//----   ,      
   PlotIndexSetDouble(3,PLOT_EMPTY_VALUE,0);

//----     
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits);
//----         
   string short_name="AdaptiveRenko";
   IndicatorSetString(INDICATOR_SHORTNAME,short_name);
//----   
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate
(const int rates_total,
 const int prev_calculated,
 const datetime &Time[],
 const double &Open[],
 const double &High[],
 const double &Low[],
 const double &Close[],
 const long &Tick_Volume[],
 const long &Volume[],
 const int &Spread[]
 )
  {
//----       
   if(BarsCalculated(Ind_Handle)<rates_total || rates_total<min_rates_total) return(RESET);

//----    
   int to_copy,limit,bar,trend;
   double Hi,Lo,vlt,Brick,Up,Dn;
   double IndArray[];
   static double Brick_,Up_,Dn_;
   static int trend_;

//----         
   ArraySetAsSeries(High,true);
   ArraySetAsSeries(Low,true);
   ArraySetAsSeries(Close,true);
   ArraySetAsSeries(IndArray,true);

//----      
//  limit    
   if(prev_calculated>rates_total || prev_calculated<=0)//      
     {
      limit=rates_total-min_rates_total-1; //      
      if(Price==Close_) {Hi=Close[limit]; Lo=Hi;}
      else {Hi=High[limit]; Lo=Low[limit];}
      Brick_=MathMax(K*(Hi-Lo),sens);
      Up_=Hi;
      Dn_=Lo;
      trend_=0;
     }
   else limit=rates_total-prev_calculated; //      
//----   
   to_copy=limit+1;

//----      
   if(CopyBuffer(Ind_Handle,0,0,to_copy,IndArray)<=0) return(RESET);
   
//----   
   Up=Up_;
   Dn=Dn_;
   Brick=Brick_;
   trend=trend_;

//----    
   for(bar=limit; bar>=0 && !IsStopped(); bar--)
     {
      if(Price==Close_) {Hi=Close[bar]; Lo=Hi;}
      else {Hi=High[bar]; Lo=Low[bar];}

      vlt=MathMax(K*IndArray[bar],sens);

      if(Hi>Up+Brick)
        {
         if(Brick) Up+=MathFloor((Hi-Up)/Brick)*Brick;
         Brick=vlt;
         Dn=Up-Brick;
        }

      if(Lo<Dn-Brick)
        {
         if(Brick) Dn-=MathFloor((Dn-Lo)/Brick)*Brick;
         Brick=vlt;
         Up=Dn+Brick;
        }

      UpBuffer[bar]=Up;
      DnBuffer[bar]=Dn;
      UpTrendBuffer[bar]=0.0;
      DnTrendBuffer[bar]=0.0;

      if(UpBuffer[bar+1]<UpBuffer[bar]) trend=+1;
      if(DnBuffer[bar+1]>DnBuffer[bar]) trend=-1;

      if(trend>0) UpTrendBuffer[bar]=DnBuffer[bar]-Brick;
      if(trend<0) DnTrendBuffer[bar]=UpBuffer[bar]+Brick;

      //----         
      if(bar)
        {
         Up_=Up;
         Dn_=Dn;
         Brick_=Brick;
         trend_=trend;
        }
     }
//----     
   return(rates_total);
  }
//+------------------------------------------------------------------+
